#include "helper.h"

using namespace std;


namespace par {


	  int min_geno_cell = 5;
	  string output_file_name = "plinkout";
	  int pp_maxsnp = 10;
	  int fisher_test = 0;
	  int adaptive_perm = 0;

	  int model_perm_best = 0;
	  int model_perm_gen = 0;
	  int model_perm_dom = 0;
	  int model_perm_rec = 0;
	  int model_perm_trend = 0;

	  int verbose = 0;

};


void sizeMatrix(matrix_t & m , int r, int c)
{
  m.clear();
  m.resize(r);
  for (int i=0; i<r; i++)
    m[i].resize(c,0);
}

void sizeTable(table_t & m , int r, int c)
{
  m.clear();
  m.resize(r);
  for (int i=0; i<r; i++)
    m[i].resize(c,0);
}


std::string int2str(int n)
{
  std::ostringstream s2( std::stringstream::out );
  s2 << n;
  return s2.str();
}

std::string longint2str(long int n)
{
  std::ostringstream s2( std::stringstream::out );
  s2 << n;
  return s2.str();
}

std::string dbl2str(double n, int prc)
{
  std::ostringstream s2;
  if ( prc > 0 )
    s2.precision(prc);
  s2 << n;
  return s2.str();
}


void display(matrix_t & m)
{
  cout << "\n";
  for (int i=0; i< m.size(); i++)
    {
      cout << i << ")\t";
      for (int j=0; j<m[i].size(); j++)
	cout << m[i][j] << " ";
      cout << "\n";
    }
  cout << "\n";
}

void display(vector_t & m)
{
  cout << "\n";
  for (int i=0; i< m.size(); i++)
    cout << i << ")\t" << m[i] << "\n";
  cout << "\n";
  cout << "\n";
}

void display(vector<int> & m)
{
  cout << "\n";
  for (int i=0; i< m.size(); i++)
    cout << i << ")\t" << m[i] << "\n";
  cout << "\n";
  cout << "\n";
}

