#include <fstream>
#include <iostream>
#include <vector>
#include <math.h>

using namespace std;


void histogram_int(vector<double> &v, int nbins, string file) {

	double n = v.size(), a = 0, x, c = 0;
	double max = v[0], min = v[0];

	double eps = 1e-10;

	vector<int> bins(nbins+10,0);

	for (int i = 0; i < n; i++) {
		if (v[i] > max) max = v[i];
		if (v[i] < min) min = v[i];
	}

	double last = 0;

	double thisbin = min + nbins;

	for (int i = 0; ; i++) {

		double c = 0; 
		for (int j = 0; j < n; j++) if(v[j] <= thisbin + eps) c++;

		cout << thisbin << " " << ((c-last)/v.size()) << "\n";
		last = c;
		thisbin += nbins;
		//thisbin+=2;
		//thisbin *= 1.03;

		if(c==v.size()) break;
	}

	//for (int i = 0; i < n; i++) {
	//	int b = (int) (0.0 + nbins * (v[i] - min) / max);
	//	bins[b]++;
	//}

	//for (int i = 0; i < nbins; i++) {
	//	cout << (min + ((i - 0.0) * max / nbins)) << " " << bins[i] << "\n";
	//}

}



void histogram(vector<double> &v, int nbins, string file) {

	double n = v.size(), a = 0, x, c = 0;
	double max = v[0], min = v[0];

	double eps = 1e-10;

	vector<int> bins(nbins+10,0);

	for (int i = 0; i < n; i++) {
		if (v[i] > max) max = v[i];
		if (v[i] < min) min = v[i];
	}

	double last = 0;

	double thisbin = min + fabs(max-min)/nbins;

	for (int i = 0; ; i++) {

		double c = 0; 
		for (int j = 0; j < n; j++) if(v[j] <= thisbin + eps) c++;

		cout << thisbin << " " << ((c-last)/v.size()) << "\n";
		last = c;
		thisbin += fabs(max-min)/nbins;
		//thisbin+=2;
		//thisbin *= 1.03;

		if(c==v.size()) break;
	}

	//for (int i = 0; i < n; i++) {
	//	int b = (int) (0.0 + nbins * (v[i] - min) / max);
	//	bins[b]++;
	//}

	//for (int i = 0; i < nbins; i++) {
	//	cout << (min + ((i - 0.0) * max / nbins)) << " " << bins[i] << "\n";
	//}

}

int getrand(int l,int u)
{

double g = drand48();
double s = u-l;

return l + round(s*g);

}


vector<double> resample(vector<double> &v)
{
	vector<double> x;

	int l = v.size();

	for(int i=0;i<100*l;i++) {
		int a = getrand(0,l-1);
		int b = getrand(0,l-1);
		x.push_back( (v[a]+v[b])/2 );

	}

	return x;

}

main(int argc,char *argv[])
{
	vector <double> v;
	double f;
	int bins = atoi(argv[1]);

	srand48(time(NULL));



	while(cin >> f) {
		//f = -log10(f);
		v.push_back(f);
	}

	if(argc == 3) v = resample(v);

	
	if(bins > 0) histogram(v,bins,"t");
	if(bins < 0) histogram_int(v,-bins,"t");

}