#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>
#include <sstream>
#include <map>

using namespace std;

const int max = 1000000;

template<class M>
class matrix : public vector< vector <M> >
{
	public:
	void resize2d(int a,int b) {
		this->resize(a);
		for(int i=0; i<a; i++)
			this->operator[](i).resize(b);
	}
};


map<string,string> snpmap;

void 
readmap(string file)
{
	ifstream in;
	in.open(file.c_str());
	string a1,a2,a3,a4,a5,a6;

	while(in) {
		in >> a1 >> a2 >> a3 >> a4 >> a5;
		snpmap[a4] = a5;
	}
	
}



template <class M>
matrix<M> transpose(const matrix<M> &A)
{
	matrix<M> B;
	B.resize2d(A[0].size(),A.size());
	cout << "B.size=" << B.size() << " " << B[0].size() << "\n";

	for(int i=0;i<A.size(); i++) {
		for(int j=0;j<A[i].size(); j++) {
			B[j][i] = A[i][j];
		}
	}

	return B;
}

string join(vector<string> &f, string delim = " ") 
{
	int i;
	string s = "";
	for(i=0;i<f.size()-1;i++) { s += f[i]; s += " "; }
	s  += f[f.size()-1];
	return s;
}


matrix<string> snp, per, geno;

main(int argc, char *argv[])
{

    cout << "Join WTCCC tped/tfam case control data into a single tped & tfam file.\n";
    string p1, p2, p3, p4, p5, p6, p7;

    int n;

    string t;

    ifstream tfam[10], tped[10];
    string pheno[10];

    ifstream conf;
    conf.open(argv[1]);

    string mapfile;

    conf >> mapfile;
    readmap(mapfile);

    cout << "read " << snpmap.size() << " snp map entries\n";

    conf >> n; // number of file sets

    int i, j;
    for (i = 0; i < n; i++) {
        conf >> t;
        tfam[i].open(t.c_str());

        conf >> t;
        tped[i].open(t.c_str());

        conf >> pheno[i];
    }

    ofstream out;
    out.open("out.tfam");

    for (i = 0; i < n; i++)
        while (tfam[i]) {
		vector<string> t;
		t.resize(6);

            tfam[i] >> t[0] >> t[1] >> t[2] >> t[3] >> t[4] >> t[5];
            if (!tfam[i]) break;

            t[5] = pheno[i];
		
		per.push_back(t);
	out << join(t," ") << "\n";
        }

    ofstream out_tped;
    out_tped.open("out.tped");

    string t1[20], t2[20], t3[20], t4[20];
    string line[20];


    while (tped[0]) {
        for (i = 0; i < n; i++) {
            tped[i] >> t1[i] >> t2[i] >> t3[i] >> t4[i];
            getline(tped[i], line[i]);

		string r = snpmap[ t2[i] ] ;
		if(r.size() > 0) t2[i] = r;
	    //cout << t2[i] << " " << snpmap[ t2[i] ] << "\n";

        }

        int c = 0;
        for (i = 0; i < n; i++) if (!tped[i]) c++;
        if (c >= n) break;


        for (i = 0; i < n - 1; i++) if (t2[i] != t2[i + 1]) {

                cout << "Mismatched snp location:\n";
                for (j = 0; j < n; j++) cout << "." << t2[j] << "." << " "; cout << "\n";
                exit(1);

            }

        out_tped << t1[0] << " " << t2[0] << " " << t3[0] << " " << t4[0] << " ";
        for (i = 0; i < n - 1; i++) out_tped << line[i] << " ";

        out_tped << line[n - 1] << "\n";

    }
}
